<template>
  <div :class="$style.searchInputWrap">
    <input
      :value="value"
      :class="$style.searchInput"
      placeholder="Поиск"
      @input="$emit('input', $event.target.value)"
      @keyup.enter="$emit('press-enter')"
      v-bind="$attrs"
    />
    <icon-btn :class="$style.searchBtn" @click="clearSearch()">
      <CloseIcon v-if="isSearching" />
      <SearchIcon v-else />
    </icon-btn>
  </div>
</template>

<script>
import IconBtn from "./icon-btn";
import SearchIcon from "../../assets/images/icons/search.svg";
import CloseIcon from "../../assets/images/icons/close.svg";

export default {
  name: "SearchInput",
  components: { IconBtn, SearchIcon, CloseIcon },
  props: {
    value: {
      type: String
    }
  },
  computed: {
    isSearching() {
      return this.value.length > 0;
    }
  },
  methods: {
    clearSearch() {
      if (this.isSearching) {
        this.$emit("on-clear-search");
      }
    }
  }
};
</script>

<style lang="scss" module>
@import "../../shared/styles/imports.scss";

.searchInputWrap {
  position: relative;
}

.searchInput {
  @include searchField();

  width: 100%;
  height: $searchBlockHeight;
  padding: 12px $searchBlockHeight 12px 16px;
}

.searchBtn {
  position: absolute;
  top: 0;
  right: 0;
  height: $searchBlockHeight;
  width: $searchBlockHeight;
  z-index: 5;
}
</style>
